/*
 * com.simulogic.cese -- Cell Electrophysiology Simulation Environment (CESE)
 * 
 * Copyright (C) 1999 - 2005 Sergey Missan
 * 
 * Dalhousie Univ., Halifax, NS, Canada
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 *  
 */

package com.simulogic.cese.actions;

import java.awt.event.ActionEvent;

import com.simulogic.cese.ModelManager;
import com.simulogic.cese.ResourceManager;
import com.simulogic.utils.ActionSupport;

/**
 * NextHistory action implementation
 */
public class NextHistoryAction extends ActionSupport implements
		java.beans.PropertyChangeListener {

	private ModelManager manager;

	/** 
	 * Creates new NextRecAction  
     *  
     * @param m model manager
     */
	public NextHistoryAction(ModelManager m) {
		this();
		manager = m;
		manager.addPropertyChangeListener(this);
	}

	/** Creates new NextRecAction */
	public NextHistoryAction() {
		super(ResourceManager.getResource("Next_Simulation_Run"),
				ResourceManager.getResource("Next_simulation_run"),
				ResourceManager.getResource("next_image"));
	}

	public void actionPerformed(ActionEvent evt) {
		manager.getModelInfo().getHistory().setTreeSelection(
				manager.getExportTreeSelection());

		manager.getModelInfo().getHistory().nextHistory();
		manager.changeModel();

		if (manager.getModelInfo().getHistory().getHistoryNumber() >= manager
				.getModelInfo().getHistory().getMaxHistoryNumber() - 1)
			this.setEnabled(false);
	}

	public void propertyChange(java.beans.PropertyChangeEvent evt) {
		if (manager.getModelInfo() == null) {
			this.setEnabled(false);
			return;
		}
		
		if (manager.getModelInfo().getHistory().getMaxHistoryNumber() == 0) {
			this.setEnabled(false);
			return;
		}

		if (evt.getPropertyName().equals("history_control")) {
			if (manager.getModelInfo().getHistory().getHistoryNumber() < manager
					.getModelInfo().getHistory().getMaxHistoryNumber() - 1) {
				this.setEnabled(true);
			} else {
				this.setEnabled(false);
			}
		}
	}
}