<?xml version="1.0"?>
<xsl:stylesheet  version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:math="http://www.w3.org/1998/Math/MathML" >

	<xsl:strip-space elements="*"/>

	<!--Get all variable names and put them in one string with space delimiters including the ends.  Uniqueness is not accomplished here.-->
	<xsl:template name="get-variables">
		<xsl:param name="index" select="1"/>
		<xsl:for-each select="node()">
			<xsl:choose>
				<xsl:when test="local-name()='ci' and not(./*[2])">
						<xsl:choose>
						<xsl:when test="./*[position()=1 and name()='msub'] and ./*[1]/*[position()=1 and name()='mi'] and ./*[1]/*[position()=2 and name()='mn']">
							<xsl:value-of select="translate(./*[1]/*[1],' &#9;&#10;&#13;','')"/><xsl:text> </xsl:text>
						</xsl:when>
						<xsl:when test="./*[position()=1 and name()='msub'] and ./*[1]/*[position()=1 and name()='mi'] and ./*[1]/*[position()=2 and name()='mi']">
							<xsl:value-of select="translate(./*[1]/*[1],' &#9;&#10;&#13;','')"/><xsl:value-of select="translate(./*[1]/*[2],' &#9;&#10;&#13;','')"/><xsl:text> </xsl:text>
						</xsl:when>
						<xsl:when test="./*[position()=1 and name()='msub'] and ./*[1]/*[position()=1 and name()='mi'] and ./*[1]/*[position()=2 and name()='apply']">
							<xsl:value-of select="translate(./*[1]/*[1],' &#9;&#10;&#13;','')"/><xsl:text> </xsl:text>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="translate(.,' &#9;&#10;&#13;','')"/><xsl:text> </xsl:text>
						</xsl:otherwise>
						</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="get-variables">
						<xsl:with-param name="index" select="$index+1"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:for-each>
	</xsl:template>
	<!--Need all the variable type too. This does the same search of the document as get-variables but gets the types instead of names-->
	<xsl:template name="get-types">
		<xsl:param name="index" select="1"/>
		<xsl:for-each select="node()">
			<xsl:choose>
				<xsl:when test="local-name()='ci'">
					<xsl:if test="not(string-length(@type)=0)">
						<xsl:choose>
						<xsl:when test="./*[position()=1 and name()='msub'] and ./*[1]/*[position()=1 and name()='mi'] and ./*[1]/*[position()=2 and name()='mn']">
							<xsl:value-of select="@type"/><xsl:text>[] </xsl:text>
						</xsl:when>
						<xsl:when test="./*[position()=1 and name()='msub'] and ./*[1]/*[position()=1 and name()='mi'] and ./*[1]/*[position()=2 and name()='mi']">
							<xsl:value-of select="@type"/><xsl:text>[] </xsl:text>
						</xsl:when>
						<xsl:when test="./*[position()=1 and name()='msub'] and ./*[1]/*[position()=1 and name()='mi'] and ./*[1]/*[position()=2 and name()='apply']">
							<xsl:value-of select="@type"/><xsl:text>[] </xsl:text>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="@type"/><xsl:text> </xsl:text>
						</xsl:otherwise>
						</xsl:choose>
					</xsl:if>
					<xsl:if test="string-length(@type)=0">
						<xsl:text>double </xsl:text>
					</xsl:if>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="get-types">
						<xsl:with-param name="index" select="$index+1"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="variables">
		<xsl:param name="index" select="1"/>
		<xsl:variable name="variable-list">
			<xsl:for-each select="node()">
				<xsl:choose>
					<xsl:when test="local-name()='ci'">
						<xsl:text> </xsl:text>
						<xsl:choose>
						<xsl:when test="./*[position()=1 and name()='msub'] and ./*[1]/*[position()=1 and name()='mi'] and ./*[1]/*[position()=2 and name()='mn']">
							<xsl:value-of select="translate(./*[1]/*[1],' &#9;&#10;&#13;','')"/>
						</xsl:when>
						<xsl:when test="./*[position()=1 and name()='msub'] and ./*[1]/*[position()=1 and name()='mi'] and ./*[1]/*[position()=2 and name()='mi']">
							<xsl:value-of select="translate(./*[1]/*[1],' &#9;&#10;&#13;','')"/>
						</xsl:when>
						<xsl:when test="./*[position()=1 and name()='msub'] and ./*[1]/*[position()=1 and name()='mi'] and ./*[1]/*[position()=2 and name()='apply']">
							<xsl:value-of select="translate(./*[1]/*[1],' &#9;&#10;&#13;','')"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="translate(.,' &#9;&#10;&#13;','')"/>
						</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="get-variables">
							<xsl:with-param name="index" select="$index+1"/>
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each><xsl:text> </xsl:text>
		</xsl:variable>
		<xsl:variable name="type-list">
			<xsl:for-each select="node()">
				<xsl:choose>
					<xsl:when test="local-name()='ci'">
						<xsl:if test="not(string-length(@type)=0)">
							<xsl:text> </xsl:text>
							<xsl:value-of select="@type"/>
						</xsl:if>
						<xsl:if test="string-length(@type)=0">
							<xsl:text> double</xsl:text>
						</xsl:if>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="get-types">
							<xsl:with-param name="index" select="$index+1"/>
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each><xsl:text> </xsl:text>
		</xsl:variable>
        //<xsl:value-of select="$variable-list"/>
        //<xsl:value-of select="$type-list"/>
		<xsl:call-template name="define-variables">
			<xsl:with-param name="list" select="$variable-list"/>
			<xsl:with-param name="type-list" select="$type-list"/>
			<!--xsl:with-param name="list" select="substring-after($variable-list, ' ')"/>
			<xsl:with-param name="type-list" select="substring-after($type-list, ' ')"/-->
		</xsl:call-template>
	</xsl:template>

	<xsl:template name="define-variables">
		<xsl:param name="unique-list" select="string(' ')"/>
		<xsl:param name="list" select="string(' ')"/>
		<xsl:param name="type-list" select="string(' ')"/>
		<xsl:param name="index" select="1"/>
		<xsl:param name="current-variable" select="substring-before($list, ' ')"/>
		<xsl:param name="current-type" select="substring-before($type-list, ' ')"/>
		<xsl:variable name="type-Java-type">
			<xsl:choose>
				<xsl:when test="$current-type='matrix'">
					<xsl:text>javax.vecmath.GMatrix</xsl:text>
				</xsl:when>
				<xsl:when test="$current-type='vector'">
					<xsl:text>javax.vecmath.GVector</xsl:text>
				</xsl:when>
				<xsl:when test="$current-type='complex-cartesian'">
					<xsl:text>com.pombi.mathml.lang.ComplexDouble</xsl:text>
				</xsl:when>
				<xsl:when test="$current-type='complex-cartesian[]'">
					<xsl:text>com.pombi.mathml.lang.ComplexDouble[]</xsl:text>
				</xsl:when>
				<xsl:when test="$current-type='real[]'">
					<xsl:text>double[]</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>double</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="not(contains($unique-list, $current-variable))">
    public void set<xsl:call-template name="capitalize-first-letter">
					<xsl:with-param name="current-variable" select="$current-variable"/>
				</xsl:call-template>(<xsl:value-of select="$type-Java-type"/> new<xsl:call-template name="capitalize-first-letter">
					<xsl:with-param name="current-variable" select="$current-variable"/>
				</xsl:call-template>)
    {
        <xsl:value-of select="$current-variable"/>=new<xsl:call-template name="capitalize-first-letter">
					<xsl:with-param name="current-variable" select="$current-variable"/>
				</xsl:call-template>;
    }

    public <xsl:value-of select="$type-Java-type"/> get<xsl:call-template name="capitalize-first-letter">
					<xsl:with-param name="current-variable" select="$current-variable"/>
				</xsl:call-template>()
    {
        return <xsl:value-of select="$current-variable"/>;
    }

        <xsl:choose>
					<xsl:when test="$current-type='matrix'">
    protected <xsl:value-of select="$type-Java-type"/>
						<xsl:text> </xsl:text>
						<xsl:value-of select="$current-variable"/>=null;
            </xsl:when>
					<xsl:when test="$current-type='vector'">
    protected <xsl:value-of select="$type-Java-type"/>
						<xsl:text> </xsl:text>
						<xsl:value-of select="$current-variable"/>=null;
            </xsl:when>
					<xsl:when test="$current-type='complex-cartesian'">
    protected <xsl:value-of select="$type-Java-type"/>
						<xsl:text> </xsl:text>
						<xsl:value-of select="$current-variable"/>=null;
            </xsl:when>
					<xsl:when test="$current-type='complex-cartesian[]'">
    protected <xsl:value-of select="$type-Java-type"/>
						<xsl:text> </xsl:text>
						<xsl:value-of select="$current-variable"/>=null;
            </xsl:when>
					<xsl:when test="$current-type='real[]'">
    protected <xsl:value-of select="$type-Java-type"/>
						<xsl:text> </xsl:text>
						<xsl:value-of select="$current-variable"/>=null;
            </xsl:when>
					<xsl:otherwise>
    protected <xsl:value-of select="$type-Java-type"/>
						<xsl:text> </xsl:text>
						<xsl:value-of select="$current-variable"/>=0.0;
            </xsl:otherwise>
				</xsl:choose>
				<!--xsl:choose>
            <xsl:when test="contains(substring-after($list, ' '), ' ') ">
              <xsl:call-template name="define-variables">
                <xsl:with-param name="unique-list" select="concat($unique-list,' ',$current-variable)"/>
                <xsl:with-param name="list" select="substring-after($list, ' ')"/>
                <xsl:with-param name="type-list" select="substring-after($type-list, ' ')"/>
                <xsl:with-param name="index" select="$index+1"/>
              </xsl:call-template>
            </xsl:when-->
			</xsl:when>
		</xsl:choose>
		<xsl:choose>
			<xsl:when test="contains(substring-after($list, ' '), ' ') ">
				<xsl:call-template name="define-variables">
					<xsl:with-param name="unique-list" select="concat($unique-list,' ',$current-variable)"/>
					<xsl:with-param name="list" select="substring-after($list, ' ')"/>
					<xsl:with-param name="type-list" select="substring-after($type-list, ' ')"/>
					<xsl:with-param name="index" select="$index+1"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise/>
		</xsl:choose>
	</xsl:template>
	<!--Set the variable type-->
	<xsl:template name="set-type">
		<xsl:param name="current-type" select="void"/>
		<xsl:choose>
			<xsl:when test="$current-type='matrix'">
				<xsl:text>javax.vecmath.GMatrix</xsl:text>
			</xsl:when>
			<xsl:when test="$current-type='vector'">
				<xsl:text>javax.vecmath.GVector</xsl:text>
			</xsl:when>
			<xsl:when test="$current-type='complex-cartesian'">
				<xsl:text>com.pombi.mathml.lang.ComplexDouble</xsl:text>
			</xsl:when>
			<xsl:when test="$current-type='complex-cartesian[]'">
				<xsl:text>com.pombi.mathml.lang.ComplexDouble[]</xsl:text>
			</xsl:when>
			<xsl:when test="$current-type='integer'">
				<xsl:text>int</xsl:text>
			</xsl:when>
			<xsl:when test="$current-type='void'">
				<xsl:text>void</xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>double</xsl:text>
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>
	<!--Set the argument as type and variable name -->
	<xsl:template name="set-argument">
		<xsl:param name="current-variable" select="' '"/>
		<xsl:param name="current-type" select="void"/>
		<xsl:call-template name="set-type">
			<xsl:with-param name="current-type" select="$current-type"/>
		</xsl:call-template><xsl:if test="./*[position()=1 and local-name()='msub']">[]</xsl:if><xsl:text> </xsl:text><xsl:value-of select="$current-variable"/>
	</xsl:template>
	<!--Brute force capitalization of the first letter till xslt2.0-->
	<xsl:template name="capitalize-first-letter">
		<xsl:param name="current-variable" select="string(' ')"/>
		<xsl:copy-of select="translate(substring($current-variable,1,1),'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>
		<xsl:if test="string-length($current-variable)&gt;1">
			<xsl:copy-of select="substring($current-variable,2,string-length($current-variable))"/>
		</xsl:if>
	</xsl:template>
	<!--xsl:template name="find-function">
		<xsl:param name="function-description" select="'fx'"/>
		<xsl:param name="starting-location"><xsl:call-template name="recurseBackToRoot"/></xsl:param>
		//<xsl:value-of select="$starting-location"/>
		<xsl:for-each select="$starting-location/node()">
		//<xsl:value-of select="local-name(.)"/>
			<xsl:choose>
				<xsl:when test="local-name(.)='csymbol' and concat(., ../*[2])=$function-description">
					<xsl:copy-of select="../*[2]"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="find-function">
						<xsl:with-param name="function-description" select="$function-description"/>
						<xsl:with-param name="starting-location" select="."/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="recurseBackToRoot">
	<xsl:param name="treePath" select="string('..')"/>
	<xsl:choose>
	<xsl:when test="name()='math'">
	<xsl:value-of select="$treePath"/>
	</xsl:when>
	<xsl:otherwise>
	<xsl:for-each select="..">
	<xsl:call-template name="recurseBackToRoot" >
	<xsl:with-param name="treePath" select="concat('../',$treePath)"/>
	</xsl:call-template>
	</xsl:for-each>
	</xsl:otherwise>
	</xsl:choose>
	</xsl:template-->

	<!--Brute force capitalization of the first letter till xslt2.0-->
	<xsl:template name="x3d-type-conversion">
		<xsl:param name="current-type" select="string('SFFloat')"/>
		<xsl:choose>
                    <xsl:when test="$current-type='SFFloat'">float</xsl:when>
                    <xsl:when test="$current-type='SFBool'">boolean</xsl:when>
                    <xsl:when test="$current-type='SFTime'">long</xsl:when>
                    <xsl:otherwise>double</xsl:otherwise>
                </xsl:choose>
	</xsl:template>

</xsl:stylesheet>